/*

  Prototipo della classe SparseMatrix.
  Consente di definire una matrice sparsa e risolvere
  un sistema Ax = b utilizzando il metodo delle
  iterazioni di Jacobi.

 */

#ifndef JACOBI_H

#define JACOBI_H

struct listElement
{
  int num;
  long int *cols;
  double *vals;
};

class SparseMatrix
{

 private:
  long int dim, numDiags;
  double *temp;
  double *diag;
  listElement *mat;

 public:
  SparseMatrix( long int, int );    // costruttore della classe
  ~SparseMatrix( );                 // distruttore
  // setta la diagonale della matrice, per elemento j-esimo
  void setDiagonal( long int, double );
  // setta elemento i,j fuori diagonale
  void setOffDiagonal( long int, long int, double );
  // singola iterazione di Jacobi
  void iterationStep( double *, double *, double & );

};

#endif
